import { autocompletion as C, closeBrackets as w, completionKeymap as H, closeBracketsKeymap as N } from "@codemirror/autocomplete";
import { indentWithTab as j } from "@codemirror/commands";
import { css as O } from "@codemirror/lang-css";
import { html as T } from "@codemirror/lang-html";
import { json as V } from "@codemirror/lang-json";
import { yaml as K } from "@codemirror/lang-yaml";
import { syntaxHighlighting as L, defaultHighlightStyle as R, indentOnInput as A, bracketMatching as B } from "@codemirror/language";
import { linter as I } from "@codemirror/lint";
import { StateEffect as z } from "@codemirror/state";
import { EditorView as d, highlightSpecialChars as J, keymap as v, lineNumbers as P } from "@codemirror/view";
import { ref as U, watch as m, onBeforeUnmount as W, toValue as r, computed as q } from "vue";
import { customTheme as D } from "../themes/index.js";
import { variables as G } from "./variables.js";
const u = (e) => "provider" in e && !!r(e.provider), Q = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, le = (e) => {
  const o = U(null);
  m(
    e.codeMirrorRef,
    () => {
      var t;
      (t = o.value) == null || t.destroy(), s();
    },
    { immediate: !0 }
  ), W(() => {
    var t;
    return (t = o.value) == null ? void 0 : t.destroy();
  });
  function s() {
    if (e.codeMirrorRef.value) {
      const t = u(e) ? r(e.provider) : null, h = b({
        ...l.value,
        provider: t
      });
      o.value = new d({
        parent: e.codeMirrorRef.value,
        extensions: h
      }), u(e) || n(r(e.content));
    }
  }
  const l = q(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    language: r(e.language),
    classes: r(e.classes),
    readOnly: r(e.readOnly),
    lineNumbers: r(e.lineNumbers),
    withVariables: r(e.withVariables),
    disableEnter: r(e.withVariables),
    withoutTheme: r(e.withoutTheme),
    lint: r(e.lint),
    additionalExtensions: r(e.extensions)
  }));
  m(
    () => u(e) ? r(e.provider) : null,
    () => {
      var t;
      u(e) && ((t = o.value) == null || t.destroy(), s());
    }
  ), m(
    l,
    () => {
      if (o.value) {
        const t = u(e) ? r(e.provider) : null, h = b({
          ...l.value,
          provider: t
        });
        o.value.dispatch({
          effects: z.reconfigure.of(h)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const n = (t = "") => {
    o.value && o.value.state.doc.toString() !== t && o.value.dispatch({
      changes: {
        from: 0,
        to: o.value.state.doc.length,
        insert: t
      },
      selection: {
        anchor: Math.min(
          o.value.state.selection.main.anchor,
          t.length
        )
      }
    });
  };
  return m(
    () => r(e.content),
    () => {
      u(e) || n(r(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: n,
    /** Codemirror instance */
    codeMirror: o
  };
}, p = {
  html: T,
  json: V,
  yaml: K,
  css: O
};
function b({
  onChange: e,
  onBlur: o,
  onFocus: s,
  provider: l,
  language: n,
  classes: t = [],
  readOnly: h = !1,
  lineNumbers: y = !1,
  withVariables: x = !1,
  disableEnter: E = !1,
  withoutTheme: M = !1,
  lint: S = !1,
  additionalExtensions: k = []
}) {
  const i = [
    J(),
    L(R, { fallback: !0 }),
    d.theme({
      ".cm-line": {
        lineHeight: "20px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      }
    }),
    // Listen to updates
    d.updateListener.of((c) => {
      c.docChanged && (e == null || e(c.state.doc.toString()));
    }),
    d.domEventHandlers({
      blur: (c, f) => {
        o == null || o(f.state.doc.toString());
      },
      focus: (c, f) => {
        s == null || s(f.state.doc.toString());
      }
    }),
    // Add Classes
    d.editorAttributes.of({ class: t.join(" ") }),
    ...k
  ];
  if (l && i.push(l), M || i.push(D), h ? i.push(d.editable.of(!1)) : i.push(
    A(),
    B(),
    C(),
    w(),
    v.of([
      ...H,
      ...N,
      j,
      Q
    ])
  ), n && p[n] && i.push(p[n]()), S && n === "json") {
    const c = I((f) => {
      const a = [];
      try {
        JSON.parse(f.state.doc.toString());
      } catch (g) {
        g instanceof Error && a.push({
          from: 0,
          to: f.state.doc.length,
          severity: "error",
          message: g.message
        });
      }
      return a;
    });
    i.push(c);
  }
  return y && i.push(P()), x && i.push(G()), E && i.push(
    v.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ), i;
}
export {
  le as useCodeMirror
};
